#ifndef KERNEL_H
#define KERNEL_H

#define MAX_NUM_PRIORITY 8
#define MAX_NUM_TD 10


typedef struct kernel {
    TDPQ* ArrayPQ[MAX_NUM_PRIORITY];
    TD ArrayTDAvail[MAX_NUM_TD]; //TODO
    // a free list of pointers to free TDs. This might take the form of bits set in a couple of words.
    // a structure for keeping the request currently being serviced, including its arguments.
    int CurRequest;
} KernelStruct;


void kernelInit (KernelStruct* Colonel);

void activate(KernelStruct* Colonel); // TODO Will have to return a request

void handle(KernelStruct* Colonel, Request* syscallRequest);

#endif
