#ifndef TASK_DESCRIPTOR_H
#define TASK_DESCRIPTOR_H

typedef enum taskstate {
    Active, 
    Ready, 
    Blocked
} State;


typedef struct taskDescriptor {
    int TaskID;
    int ParentID;
    State TaskState;
    unsigned int* StackPtr; 
    TD* Next;
    void* RetVal;
    int TaskPriority; 
    char* Stack;
    TD* Parent;
    Request* Req;
} TD;

int TDinit();

// allocTD
// deallocTD
// get TD


#endif
