/* copied from the ARM architecture manual */

swi n // n being Create, Pass, Exit, etc.
R14_svc = address of next instruction after the SWI instruction
SPSR_svc = CPSR
CPSR[4:0] = 0b10011 /* Enter Supervisor mode */
CPSR[5] = 0 /* Execute in ARM state */
 /* CPSR[6] is unchanged */
CPSR[7] = 1 /* Disable normal interrupts */
 /* CPSR[8] is unchanged */
CPSR[9] = CP15_reg1_EEbit /* Endianness on exception entry */
if high vectors configured then
PC = 0xFFFF0008
else
PC = 0x00000008

movs pc, lr // jump outta kernel
